<script setup lang="ts">
import { useUserStore } from "@/stores/users";
import { useRoute, useRouter } from "vue-router";
import { watch, ref, computed } from "vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useSettingsStore } from "@/stores/settings";
import { environment } from "@/environment";

const userRepository = useUserStore();
const settingsStore = useSettingsStore();
const route = useRoute();
const router = useRouter();

function logout() {
  userRepository.logout();
  router.push({ name: "login" });
}

const activeRoute = ref("");
const objectStorageActive = computed<boolean>(
  () => activeRoute.value == "buckets" || activeRoute.value == "s3_keys",
);
const workflowActive = computed<boolean>(
  () => activeRoute.value == "workflows",
);
const resourceActive = computed<boolean>(() => activeRoute.value == "resource");
const adminActive = computed<boolean>(() => activeRoute.value == "admin");

watch(
  () => route.name,
  (to) => {
    if (typeof to === "string") {
      if (to.startsWith("bucket")) {
        activeRoute.value = "buckets";
      } else if (to.startsWith("workflow")) {
        activeRoute.value = "workflows";
      } else if (to.startsWith("resource")) {
        activeRoute.value = "resource";
      } else if (to.startsWith("admin")) {
        activeRoute.value = "admin";
      } else {
        activeRoute.value = to;
      }
    } else {
      activeRoute.value = "";
    }
  },
);
</script>

<template>
  <header
    class="navbar navbar-expand bd-navbar sticky-top border-bottom border-secondary"
  >
    <nav
      class="container-fluid container-xxxl bd-gutter flex-wrap flex-lg-nowrap text-light"
    >
      <router-link
        class="navbar-brand text-white d-flex align-items-center"
        :class="{ 'flex-grow-1': !userRepository.authenticated }"
        :to="{
          name: userRepository.authenticated ? 'dashboard' : 'home',
        }"
      >
        <img
          src="/src/assets/images/clowm.svg"
          alt="CloWM Icon"
          width="32"
          height="32"
          class="d-inline-block align-text-top me-2"
        />
        CloWM
      </router-link>

      <div v-if="userRepository.authenticated" class="d-flex flex-grow-1">
        <ul class="navbar-nav">
          <li class="nav-item dropdown">
            <a
              id=""
              class="nav-link dropdown-toggle"
              :class="{ 'text-light': objectStorageActive }"
              href="#"
              role="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
              data-bs-auto-close="true"
            >
              Files
            </a>
            <ul
              class="dropdown-menu shadow m-0"
              aria-labelledby="objectStoreDropdown"
            >
              <li>
                <router-link class="dropdown-item" :to="{ name: 'buckets' }"
                  >My Data Buckets
                </router-link>
              </li>
              <li>
                <router-link class="dropdown-item" :to="{ name: 's3_keys' }"
                  >S3 Bucket Keys
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 's3_multipart-uploads' }"
                  >Multipart Uploads
                </router-link>
              </li>
            </ul>
          </li>
          <li class="nav-item dropdown">
            <a
              id="workflowDropdown"
              class="nav-link dropdown-toggle"
              :class="{ 'text-light': workflowActive }"
              href="#"
              role="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
              data-bs-auto-close="true"
            >
              Workflows
            </a>
            <ul
              class="dropdown-menu shadow m-0"
              aria-labelledby="workflowDropdown"
            >
              <li>
                <router-link class="dropdown-item" :to="{ name: 'workflows' }"
                  >Available Workflows
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'workflow-executions' }"
                  >My Workflow Executions
                </router-link>
              </li>
              <li
                v-if="
                  userRepository.workflowDev ||
                  userRepository.reviewer ||
                  userRepository.admin
                "
              >
                <hr class="dropdown-divider" />
              </li>
              <li v-if="userRepository.workflowDev || userRepository.admin">
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'workflows-developer' }"
                  >My Workflows
                </router-link>
              </li>
              <li v-if="userRepository.reviewer || userRepository.admin">
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'workflows-reviewer' }"
                  >Reviews
                </router-link>
              </li>
            </ul>
          </li>
          <li class="nav-item dropdown">
            <a
              id="resourceDropdown"
              class="nav-link dropdown-toggle"
              :class="{ 'text-light': resourceActive }"
              href="#"
              role="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
              data-bs-auto-close="true"
            >
              Resources
            </a>
            <ul
              class="dropdown-menu shadow m-0 dropdown-menu-end"
              aria-labelledby="workflowDropdown"
            >
              <li>
                <router-link class="dropdown-item" :to="{ name: 'resources' }"
                  >Available Resources
                </router-link>
              </li>
              <li
                v-if="
                  userRepository.resourceMaintainer ||
                  userRepository.reviewer ||
                  userRepository.admin
                "
              >
                <hr class="dropdown-divider" />
              </li>
              <li
                v-if="userRepository.resourceMaintainer || userRepository.admin"
              >
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'resource-maintainer' }"
                  >My Resources
                </router-link>
              </li>
              <li v-if="userRepository.reviewer || userRepository.admin">
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'resource-review' }"
                  >Reviews
                </router-link>
              </li>
            </ul>
          </li>
          <li v-if="userRepository.admin">
            <a
              id="adminDropdown"
              class="nav-link dropdown-toggle"
              :class="{ 'text-light': adminActive }"
              href="#"
              role="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
              data-bs-auto-close="true"
            >
              Admin
            </a>
            <ul
              class="dropdown-menu shadow m-0 dropdown-menu-end"
              aria-labelledby="adminDropdown"
            >
              <li>
                <router-link class="dropdown-item" :to="{ name: 'admin-users' }"
                  >Users
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'admin-tokens' }"
                  >API tokens
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'admin-buckets' }"
                  >Buckets
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'admin-executions' }"
                  >Workflow Executions
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'admin-resources' }"
                  >Resources
                </router-link>
              </li>
              <li>
                <router-link
                  class="dropdown-item"
                  :to="{ name: 'admin-sync-requests' }"
                  >Resources Synchronization
                </router-link>
              </li>
            </ul>
          </li>
        </ul>
      </div>
      <div class="dropdown px-2">
        <button
          class="btn btn-link nav-link dropdown-toggle d-flex align-items-center"
          data-bs-toggle="dropdown"
          aria-expanded="false"
        >
          <font-awesome-icon
            :icon="`fa-solid fa-${settingsStore.lightThemeActive ? 'sun' : 'moon'}`"
          />
        </button>
        <ul class="dropdown-menu w-fit dropdown-menu-end">
          <li>
            <button
              class="dropdown-item d-flex align-items-center"
              :class="{ active: settingsStore.lightThemeActive }"
              @click="settingsStore.setTheme('light')"
            >
              <font-awesome-icon
                icon="fa-solid fa-sun"
                class="me-2 opacity-50"
              />
              <span class="flex-grow-1">Light</span>
              <font-awesome-icon
                v-if="settingsStore.lightThemeActive"
                icon="fa-solid fa-check"
              />
            </button>
          </li>
          <li>
            <button
              class="dropdown-item d-flex align-items-center"
              :class="{ active: settingsStore.darkThemeActive }"
              @click="settingsStore.setTheme('dark')"
            >
              <font-awesome-icon
                icon="fa-solid fa-moon"
                class="me-2 opacity-50"
              />
              <span class="flex-grow-1">Dark</span>
              <font-awesome-icon
                v-if="settingsStore.darkThemeActive"
                icon="fa-solid fa-check"
              />
            </button>
          </li>
        </ul>
      </div>
      <div class="vr"></div>
      <template
        v-if="userRepository.authenticated && userRepository.user != null"
      >
        <div class="dropdown">
          <a
            id="dropdownUser"
            href="#"
            class="d-flex align-items-center text-white text-decoration-none dropdown-toggle-split"
            data-bs-toggle="dropdown"
            aria-expanded="false"
          >
            <strong class="me-2">{{ userRepository.user.display_name }}</strong>
            <img
              :src="userRepository.user.gravatar_url + '?d=mp&s=32'"
              class="rounded-circle"
              height="32"
              width="32"
              alt="profile picture"
            />
          </a>
          <ul
            class="dropdown-menu text-small shadow"
            aria-labelledby="dropdownUser"
            style="z-index: 1025 !important"
          >
            <li>
              <router-link class="dropdown-item" :to="{ name: 'profile' }">
                My Profile
              </router-link>
            </li>
            <li>
              <router-link class="dropdown-item" :to="{ name: 'api-tokens' }">
                My API tokens
              </router-link>
            </li>

            <li>
              <hr class="dropdown-divider" />
            </li>
            <li>
              <a
                class="dropdown-item"
                :href="environment.API_BASE_URL + '/auth/logout'"
                @click="logout"
                >Sign out</a
              >
            </li>
          </ul>
        </div>
      </template>
      <router-link
        v-else
        class="btn btn-info btn-sm ms-2"
        role="button"
        :to="{ name: 'login' }"
      >
        Login
      </router-link>
    </nav>
  </header>
</template>

<style scoped>
ul {
  --bs-navbar-color: rgba(255, 255, 255, 0.75) !important;
  --bs-navbar-hover-color: rgba(255, 255, 255, 0.9) !important;
  --bs-navbar-disabled-color: rgba(255, 255, 255, 0.4) !important;
}

.navbar > .container-xxxl {
  display: flex;
  flex-wrap: inherit;
  align-items: center;
  justify-content: space-between;
}
</style>
